Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3418)
@@ -1489,4 +1987,43 @@
                        ENDIF
                     ENDIF
+                    
+                CASE ( 'usm_qsws' )
+!--                 array of latent heat flux from surfaces
+!--                 land surfaces
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%qsws_eb_av) )  THEN
+                        ALLOCATE( surf_usm_h%qsws_eb_av(1:surf_usm_h%ns) )
+                        surf_usm_h%qsws_eb_av = 0.0_wp
+                    ELSE
+                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%qsws_eb_av) )  THEN
+                           ALLOCATE( surf_usm_v(l)%qsws_eb_av(1:surf_usm_v(l)%ns) )
+                           surf_usm_v(l)%qsws_eb_av = 0.0_wp
+                       ENDIF
+                    ENDIF
+                    
+                CASE ( 'usm_qsws_veg' )
+!--                 array of latent heat flux from vegetation surfaces
+!--                 land surfaces
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%qsws_veg_eb_av) )  THEN
+                        ALLOCATE( surf_usm_h%qsws_veg_eb_av(1:surf_usm_h%ns) )
+                        surf_usm_h%qsws_veg_eb_av = 0.0_wp
+                    ELSE
+                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%qsws_veg_eb_av) )  THEN
+                           ALLOCATE( surf_usm_v(l)%qsws_veg_eb_av(1:surf_usm_v(l)%ns) )
+                           surf_usm_v(l)%qsws_veg_eb_av = 0.0_wp
+                       ENDIF
+                    ENDIF
+                    
+                CASE ( 'usm_qsws_liq' )
+!--                 array of latent heat flux from surfaces with liquid
+!--                 land surfaces
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%qsws_liq_eb_av) )  THEN
+                        ALLOCATE( surf_usm_h%qsws_liq_eb_av(1:surf_usm_h%ns) )
+                        surf_usm_h%qsws_liq_eb_av = 0.0_wp
+                    ELSE
+                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%qsws_liq_eb_av) )  THEN
+                           ALLOCATE( surf_usm_v(l)%qsws_liq_eb_av(1:surf_usm_v(l)%ns) )
+                           surf_usm_v(l)%qsws_liq_eb_av = 0.0_wp
+                       ENDIF
+                    ENDIF
 !
 !--             Please note, the following output quantities belongs to the 
@@ -1554,13 +2091,13 @@
                     ENDIF
                     
-                CASE ( 'usm_t_surf' )
+                CASE ( 'usm_t_surf_wall' )
 !--                 surface temperature for surfaces
-                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_surf_av) )  THEN
-                        ALLOCATE( surf_usm_h%t_surf_av(1:surf_usm_h%ns) )
-                        surf_usm_h%t_surf_av = 0.0_wp
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_surf_wall_av) )  THEN
+                        ALLOCATE( surf_usm_h%t_surf_wall_av(1:surf_usm_h%ns) )
+                        surf_usm_h%t_surf_wall_av = 0.0_wp
                     ELSE
-                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_surf_av) )  THEN
-                           ALLOCATE( surf_usm_v(l)%t_surf_av(1:surf_usm_v(l)%ns) )
-                           surf_usm_v(l)%t_surf_av = 0.0_wp
+                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_surf_wall_av) )  THEN
+                           ALLOCATE( surf_usm_v(l)%t_surf_wall_av(1:surf_usm_v(l)%ns) )
+                           surf_usm_v(l)%t_surf_wall_av = 0.0_wp
                        ENDIF
                     ENDIF
@@ -1635,4 +2172,15 @@
                            ALLOCATE( surf_usm_v(l)%t_green_av(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_green_av = 0.0_wp
+                       ENDIF
+                    ENDIF
+                CASE ( 'usm_swc' )
+!--                 soil water content for iwl layer of walls and land
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%swc_av) )  THEN
+                        ALLOCATE( surf_usm_h%swc_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+                        surf_usm_h%swc_av = 0.0_wp
+                    ELSE
+                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%swc_av) )  THEN
+                           ALLOCATE( surf_usm_v(l)%swc_av(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
+                           surf_usm_v(l)%swc_av = 0.0_wp
                        ENDIF
                     ENDIF
@@ -1803,4 +2351,52 @@
                     ENDIF
                     
+                CASE ( 'usm_qsws' )
+!--                 array of latent heat flux from surfaces (land, roof, wall)
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%qsws_eb_av(m) =                              &
+                                          surf_usm_h%qsws_eb_av(m) +           &
+                                          surf_usm_h%qsws_eb(m)
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%qsws_eb_av(m) =                        &
+                                          surf_usm_v(l)%qsws_eb_av(m) +        &
+                                          surf_usm_v(l)%qsws_eb(m)
+                       ENDDO
+                    ENDIF
+                    
+                CASE ( 'usm_qsws_veg' )
+!--                 array of latent heat flux from vegetation surfaces (land, roof, wall)
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%qsws_veg_eb_av(m) =                              &
+                                          surf_usm_h%qsws_veg_eb_av(m) +           &
+                                          surf_usm_h%qsws_veg_eb(m)
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%qsws_veg_eb_av(m) =                        &
+                                          surf_usm_v(l)%qsws_veg_eb_av(m) +        &
+                                          surf_usm_v(l)%qsws_veg_eb(m)
+                       ENDDO
+                    ENDIF
+                    
+                CASE ( 'usm_qsws_liq' )
+!--                 array of latent heat flux from surfaces with liquid (land, roof, wall)
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%qsws_liq_eb_av(m) =                              &
+                                          surf_usm_h%qsws_liq_eb_av(m) +           &
+                                          surf_usm_h%qsws_liq_eb(m)
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%qsws_liq_eb_av(m) =                        &
+                                          surf_usm_v(l)%qsws_liq_eb_av(m) +        &
+                                          surf_usm_v(l)%qsws_liq_eb(m)
+                       ENDDO
+                    ENDIF
+                    
                 CASE ( 'usm_wghf' )
 !--                 array of heat flux from ground (wall, roof, land)
@@ -1883,17 +2479,17 @@
                     ENDIF
                     
-                CASE ( 'usm_t_surf' )
+                CASE ( 'usm_t_surf_wall' )
 !--                 surface temperature for surfaces
                     IF ( l == -1 ) THEN
                        DO  m = 1, surf_usm_h%ns
-                          surf_usm_h%t_surf_av(m) =                               &
-                                             surf_usm_h%t_surf_av(m) +            &
-                                             t_surf_h(m)
+                       surf_usm_h%t_surf_wall_av(m) =                               & 
+                                          surf_usm_h%t_surf_wall_av(m) +            &
+                                          t_surf_wall_h(m)
                        ENDDO
                     ELSE
                        DO  m = 1, surf_usm_v(l)%ns
-                          surf_usm_v(l)%t_surf_av(m) =                         &
-                                          surf_usm_v(l)%t_surf_av(m) +         &
-                                          t_surf_v(l)%t(m)
+                          surf_usm_v(l)%t_surf_wall_av(m) =                         &
+                                          surf_usm_v(l)%t_surf_wall_av(m) +         &
+                                          t_surf_wall_v(l)%t(m)
                        ENDDO
                     ENDIF
@@ -1996,4 +2592,20 @@
                     ENDIF
 
+                CASE ( 'usm_swc' )
+!--                 soil water content for  iwl layer of walls and land
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%swc_av(iwl,m) =                           &
+                                          surf_usm_h%swc_av(iwl,m) +        &
+                                          swc_h(iwl,m)
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%swc_av(iwl,m) =                     &
+                                          surf_usm_v(l)%swc_av(iwl,m) +     &
+                                          swc_v(l)%t(iwl,m)
+                       ENDDO
+                    ENDIF
+
                 CASE DEFAULT
                     CONTINUE
@@ -2156,4 +2768,52 @@
                     ENDIF
                     
+                CASE ( 'usm_qsws' )
+!--                 array of latent heat flux from surfaces (land, roof, wall)
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%qsws_eb_av(m) =                              &
+                                          surf_usm_h%qsws_eb_av(m) /           &
+                                          REAL( average_count_3d, kind=wp )
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%qsws_eb_av(m) =                        &
+                                          surf_usm_v(l)%qsws_eb_av(m) /        &
+                                          REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ENDIF
+
+                CASE ( 'usm_qsws_veg' )
+!--                 array of latent heat flux from vegetation surfaces (land, roof, wall)
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%qsws_veg_eb_av(m) =                              &
+                                          surf_usm_h%qsws_veg_eb_av(m) /           &
+                                          REAL( average_count_3d, kind=wp )
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%qsws_veg_eb_av(m) =                        &
+                                          surf_usm_v(l)%qsws_veg_eb_av(m) /        &
+                                          REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ENDIF
+                    
+                CASE ( 'usm_qsws_liq' )
+!--                 array of latent heat flux from surfaces with liquid (land, roof, wall)
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%qsws_liq_eb_av(m) =                              &
+                                          surf_usm_h%qsws_liq_eb_av(m) /           &
+                                          REAL( average_count_3d, kind=wp )
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%qsws_liq_eb_av(m) =                        &
+                                          surf_usm_v(l)%qsws_liq_eb_av(m) /        &
+                                          REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ENDIF
+                    
                 CASE ( 'usm_wghf' )
 !--                 array of heat flux from ground (wall, roof, land)
@@ -2236,16 +2896,16 @@
                     ENDIF
                     
-                CASE ( 'usm_t_surf' )
+                CASE ( 'usm_t_surf_wall' )
 !--                 surface temperature for surfaces
                     IF ( l == -1 ) THEN
                        DO  m = 1, surf_usm_h%ns
-                          surf_usm_h%t_surf_av(m) =                               &
-                                             surf_usm_h%t_surf_av(m) /            &
+                       surf_usm_h%t_surf_wall_av(m) =                               & 
+                                          surf_usm_h%t_surf_wall_av(m) /            &
                                              REAL( average_count_3d, kind=wp )
                        ENDDO
                     ELSE
                        DO  m = 1, surf_usm_v(l)%ns
-                          surf_usm_v(l)%t_surf_av(m) =                         &
-                                          surf_usm_v(l)%t_surf_av(m) /         &
+                          surf_usm_v(l)%t_surf_wall_av(m) =                         &
+                                          surf_usm_v(l)%t_surf_wall_av(m) /         &
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
@@ -2347,4 +3007,20 @@
                        ENDDO
                     ENDIF
+                    
+                CASE ( 'usm_swc' )
+!--                 soil water content for  iwl layer of walls and land
+                    IF ( l == -1 ) THEN
+                    DO  m = 1, surf_usm_h%ns
+                       surf_usm_h%swc_av(iwl,m) =                           &
+                                          surf_usm_h%swc_av(iwl,m) /        &
+                                          REAL( average_count_3d, kind=wp )
+                    ENDDO
+                    ELSE
+                       DO  m = 1, surf_usm_v(l)%ns
+                          surf_usm_v(l)%swc_av(iwl,m) =                     &
+                                          surf_usm_v(l)%swc_av(iwl,m) /     &
+                                          REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ENDIF
 
 
@@ -2406,12 +3082,12 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE usm_check_data_output( variable, unit )
-        
+
         IMPLICIT NONE
- 
-        CHARACTER(LEN=*),INTENT(IN)    ::  variable !:
-        CHARACTER(LEN=*),INTENT(OUT)   ::  unit     !:
+
+        CHARACTER(LEN=*),INTENT(IN)    ::  variable   !< 
+        CHARACTER(LEN=*),INTENT(OUT)   ::  unit       !<
 
         INTEGER(iwp)                                  :: i,j          !< index
-        CHARACTER(LEN=varnamelength)                  :: var
+        CHARACTER(LEN=varnamelength)                  :: var          !< TRIM(variable)
         INTEGER(iwp), PARAMETER                       :: nl1 = 32     !< number of directional usm variables
         CHARACTER(LEN=varnamelength), DIMENSION(nl1)  :: varlist1 = & !< list of directional usm variables
@@ -2468,4 +3144,5 @@
 
         lfound = .FALSE.
+
         var = TRIM(variable)
 
@@ -2495,5 +3172,4 @@
 10      CONTINUE
 
-!--     check if variable exists
         IF ( var(1:12) == 'usm_rad_net_'  .OR.  var(1:13) == 'usm_rad_insw_'  .OR.        &
              var(1:13) == 'usm_rad_inlw_'  .OR.  var(1:16) == 'usm_rad_inswdir_'  .OR.    &
@@ -2505,11 +3181,13 @@
              var(1:9)  == 'usm_wshf_'  .OR.  var(1:9) == 'usm_wghf_' .OR.                 &
              var(1:16) == 'usm_wghf_window_' .OR. var(1:15) == 'usm_wghf_green_' .OR.     &
-             var(1:10) == 'usm_iwghf_' .OR. var(1:17) == 'usm_iwghf_window_' .OR.         &
-             var(1:17) == 'usm_surfwintrans_' )  THEN
+             var(1:10) == 'usm_iwghf_' .OR. var(1:17) == 'usm_iwghf_window_'    .OR.      &
+             var(1:17) == 'usm_surfwintrans_' .OR.                                        &
+             var(1:9)  == 'usm_qsws_'  .OR.  var(1:13)  == 'usm_qsws_veg_'  .OR.          &
+             var(1:13) == 'usm_qsws_liq_' ) THEN
             unit = 'W/m2'
-        ELSE IF ( var(1:10) == 'usm_t_surf'   .OR.  var(1:10) == 'usm_t_wall' .OR.        &
+        ELSE IF ( var(1:15) == 'usm_t_surf_wall'   .OR.  var(1:10) == 'usm_t_wall' .OR.   &
                   var(1:12) == 'usm_t_window' .OR. var(1:17) == 'usm_t_surf_window' .OR.  &
                   var(1:16) == 'usm_t_surf_green'  .OR.                                   &
-                  var(1:11) == 'usm_t_green' .OR.                                         &
+                  var(1:11) == 'usm_t_green' .OR.  var(1:7) == 'usm_swc' .OR.             &
                   var(1:15) == 'usm_t_surf_10cm' )  THEN
             unit = 'K'
@@ -2662,4 +3340,11 @@
             IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
                 var = var(1:11)
+            ENDIF
+        ENDIF
+        IF ( var(1:8) == 'usm_swc_'  .AND.  len(TRIM(var)) >= 9 )  THEN
+!--         green layers soil water content
+            READ(var(9:9), '(I1)', iostat=istat ) iwl
+            IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
+                var = var(1:7)
             ENDIF
         ENDIF
@@ -3132,4 +3817,121 @@
                  ENDIF
               ENDIF
+              
+              
+          CASE ( 'usm_qsws' )
+!--           array of latent heat flux from surfaces
+              IF ( av == 0 )  THEN
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%qsws_eb(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%qsws_eb(m)
+                    ENDDO
+                 ENDIF
+              ELSE
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%qsws_eb_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%qsws_eb_av(m)
+                    ENDDO
+                 ENDIF
+              ENDIF
+              
+          CASE ( 'usm_qsws_veg' )
+!--           array of latent heat flux from vegetation surfaces
+              IF ( av == 0 )  THEN
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%qsws_veg_eb(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%qsws_veg_eb(m)
+                    ENDDO
+                 ENDIF
+              ELSE
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%qsws_veg_eb_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%qsws_veg_eb_av(m)
+                    ENDDO
+                 ENDIF
+              ENDIF
+              
+          CASE ( 'usm_qsws_liq' )
+!--           array of latent heat flux from surfaces with liquid
+              IF ( av == 0 )  THEN
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%qsws_liq_eb(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%qsws_liq_eb(m)
+                    ENDDO
+                 ENDIF
+              ELSE
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%qsws_liq_eb_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%qsws_liq_eb_av(m)
+                    ENDDO
+                 ENDIF
+              ENDIF
+
+
 
 
@@ -3327,5 +4129,5 @@
               ENDIF
               
-          CASE ( 'usm_t_surf' )
+          CASE ( 'usm_t_surf_wall' )
 !--           surface temperature for surfaces
               IF ( av == 0 )  THEN
@@ -3335,5 +4137,5 @@
                        j = surf_usm_h%j(m)
                        k = surf_usm_h%k(m)
-                       temp_pf(k,j,i) = t_surf_h(m)
+                       temp_pf(k,j,i) = t_surf_wall_h(m)
                     ENDDO
                  ELSE
@@ -3343,5 +4145,5 @@
                        j = surf_usm_v(l)%j(m)
                        k = surf_usm_v(l)%k(m)
-                       temp_pf(k,j,i) = t_surf_v(l)%t(m)
+                       temp_pf(k,j,i) = t_surf_wall_v(l)%t(m)
                     ENDDO
                  ENDIF
@@ -3352,5 +4154,5 @@
                        j = surf_usm_h%j(m)
                        k = surf_usm_h%k(m)
-                       temp_pf(k,j,i) = surf_usm_h%t_surf_av(m)
+                       temp_pf(k,j,i) = surf_usm_h%t_surf_wall_av(m)
                     ENDDO
                  ELSE
@@ -3360,5 +4162,5 @@
                        j = surf_usm_v(l)%j(m)
                        k = surf_usm_v(l)%k(m)
-                       temp_pf(k,j,i) = surf_usm_v(l)%t_surf_av(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%t_surf_wall_av(m)
                     ENDDO
                  ENDIF
@@ -3602,4 +4404,42 @@
                        k = surf_usm_v(l)%k(m)
                        temp_pf(k,j,i) = surf_usm_v(l)%t_green_av(iwl,m)
+                    ENDDO
+                 ENDIF
+              ENDIF
+              
+              CASE ( 'usm_swc' )
+!--           soil water content for  iwl layer of walls and land
+              IF ( av == 0 )  THEN
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = swc_h(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = swc_v(l)%t(iwl,m)
+                    ENDDO
+                 ENDIF
+              ELSE
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%swc_av(iwl,m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
+                    DO  m = 1, surf_usm_v(l)%ns
+                       i = surf_usm_v(l)%i(m)
+                       j = surf_usm_v(l)%j(m)
+                       k = surf_usm_v(l)%k(m)
+                       temp_pf(k,j,i) = surf_usm_v(l)%swc_av(iwl,m)
                     ENDDO
                  ENDIF
@@ -3658,12 +4498,14 @@
              var(1:16) == 'usm_wghf_window_'  .OR. var(1:15) == 'usm_wghf_green_' .OR.      &
              var(1:10) == 'usm_iwghf_'  .OR. var(1:17) == 'usm_iwghf_window_' .OR.          &
-             var(1:10) == 'usm_t_surf'  .OR.  var(1:10) == 'usm_t_wall'  .OR.               &
+             var(1:9) == 'usm_qsws_'  .OR.  var(1:13) == 'usm_qsws_veg_'  .OR.              &
+             var(1:13) == 'usm_qsws_liq_' .OR.                                              &
+             var(1:10) == 'usm_t_surf_wall'  .OR.  var(1:10) == 'usm_t_wall'  .OR.          &
              var(1:17) == 'usm_t_surf_window'  .OR.  var(1:12) == 'usm_t_window'  .OR.      &
-             var(1:16) == 'usm_t_surf_green'  .OR.                                          &
+             var(1:16) == 'usm_t_surf_green'  .OR. var(1:11) == 'usm_t_green' .OR.          &
              var(1:15) == 'usm_t_surf_10cm' .OR.                                            &
              var(1:9) == 'usm_surfz'  .OR.  var(1:7) == 'usm_svf'  .OR.                     & 
              var(1:7) == 'usm_dif'  .OR.  var(1:11) == 'usm_surfcat'  .OR.                  &
              var(1:11) == 'usm_surfalb'  .OR.  var(1:12) == 'usm_surfemis'  .OR.            &
-             var(1:16) == 'usm_surfwintrans'  .OR.                                          &
+             var(1:16) == 'usm_surfwintrans'  .OR. var(1:7) == 'usm_swc' .OR.               &
              var(1:9) == 'usm_skyvf' .OR. var(1:9) == 'usm_skyvft' ) THEN
 
@@ -3711,9 +4553,9 @@
                                          surf_usm_h%zw_window(k-1,m)
            ENDDO
-           surf_usm_h%dz_green(nzb_wall,m) = surf_usm_h%zw_green(nzb_wall,m)
-           DO k = nzb_wall+1, nzt_wall
-               surf_usm_h%dz_green(k,m) = surf_usm_h%zw_green(k,m) -           &
-                                         surf_usm_h%zw_green(k-1,m)
-           ENDDO
+!            surf_usm_h%dz_green(nzb_wall,m) = surf_usm_h%zw_green(nzb_wall,m)
+!            DO k = nzb_wall+1, nzt_wall
+!                surf_usm_h%dz_green(k,m) = surf_usm_h%zw_green(k,m) -           &
+!                                          surf_usm_h%zw_green(k-1,m)
+!            ENDDO
            
            surf_usm_h%dz_wall(nzt_wall+1,m) = surf_usm_h%dz_wall(nzt_wall,m)
@@ -3733,4 +4575,35 @@
            surf_usm_h%dz_window_stag(nzt_wall,m) = surf_usm_h%dz_window(nzt_wall,m)
 
+!            surf_usm_h%dz_green(nzt_wall+1,m) = surf_usm_h%dz_green(nzt_wall,m)
+! 
+!            DO k = nzb_wall, nzt_wall-1
+!                surf_usm_h%dz_green_stag(k,m) = 0.5 * (                         &
+!                            surf_usm_h%dz_green(k+1,m) + surf_usm_h%dz_green(k,m) )
+!            ENDDO
+!            surf_usm_h%dz_green_stag(nzt_wall,m) = surf_usm_h%dz_green(nzt_wall,m)
+!-------------           
+           IF (surf_usm_h%green_type_roof(m) == 2.0_wp ) then
+             soil_type = 3 !extensiv green roof
+             surf_usm_h%lai(m) = 2.0_wp
+             
+           surf_usm_h%zw_green(nzb_wall,m)         = 0.05_wp
+           surf_usm_h%zw_green(nzb_wall+1,m)       = 0.10_wp
+           surf_usm_h%zw_green(nzb_wall+2,m)       = 0.15_wp
+           surf_usm_h%zw_green(nzb_wall+3,m)       = 0.20_wp
+           ELSE
+             soil_type = 6 !intensiv green roof
+             surf_usm_h%lai(m) = 4.0_wp
+             
+           surf_usm_h%zw_green(nzb_wall,m)         = 0.05_wp
+           surf_usm_h%zw_green(nzb_wall+1,m)       = 0.10_wp
+           surf_usm_h%zw_green(nzb_wall+2,m)       = 0.40_wp
+           surf_usm_h%zw_green(nzb_wall+3,m)       = 0.80_wp
+           ENDIF
+           
+           surf_usm_h%dz_green(nzb_wall,m) = surf_usm_h%zw_green(nzb_wall,m)
+           DO k = nzb_wall+1, nzt_wall
+               surf_usm_h%dz_green(k,m) = surf_usm_h%zw_green(k,m) -           &
+                                         surf_usm_h%zw_green(k-1,m)
+           ENDDO
            surf_usm_h%dz_green(nzt_wall+1,m) = surf_usm_h%dz_green(nzt_wall,m)
 
@@ -3740,4 +4613,50 @@
            ENDDO
            surf_usm_h%dz_green_stag(nzt_wall,m) = surf_usm_h%dz_green(nzt_wall,m)
+           
+          IF ( alpha_vangenuchten == 9999999.9_wp )  THEN
+             alpha_vangenuchten = soil_pars(0,soil_type)
+          ENDIF
+
+          IF ( l_vangenuchten == 9999999.9_wp )  THEN
+             l_vangenuchten = soil_pars(1,soil_type)
+          ENDIF
+
+          IF ( n_vangenuchten == 9999999.9_wp )  THEN
+             n_vangenuchten = soil_pars(2,soil_type)            
+          ENDIF
+
+          IF ( hydraulic_conductivity == 9999999.9_wp )  THEN
+             hydraulic_conductivity = soil_pars(3,soil_type)            
+          ENDIF
+
+          IF ( saturation_moisture == 9999999.9_wp )  THEN
+             saturation_moisture = m_soil_pars(0,soil_type)           
+          ENDIF
+
+          IF ( field_capacity == 9999999.9_wp )  THEN
+             field_capacity = m_soil_pars(1,soil_type)           
+          ENDIF
+
+          IF ( wilting_point == 9999999.9_wp )  THEN
+             wilting_point = m_soil_pars(2,soil_type)            
+          ENDIF
+
+          IF ( residual_moisture == 9999999.9_wp )  THEN
+             residual_moisture = m_soil_pars(3,soil_type)       
+          ENDIF
+          
+          DO k = nzb_wall, nzt_wall+1
+             swc_h(k,m) = field_capacity
+             rootfr_h(k,m) = 0.5_wp
+             surf_usm_h%alpha_vg_green(m)      = alpha_vangenuchten
+             surf_usm_h%l_vg_green(m)          = l_vangenuchten
+             surf_usm_h%n_vg_green(m)          = n_vangenuchten 
+             surf_usm_h%gamma_w_green_sat(k,m)   = hydraulic_conductivity
+             swc_sat_h(k,m)                    = saturation_moisture
+             fc_h(k,m)                         = field_capacity
+             wilt_h(k,m)                       = wilting_point
+             swc_res_h(k,m)                    = residual_moisture
+          ENDDO
+!-------------------------------           
         ENDDO
         surf_usm_h%ddz_wall        = 1.0_wp / surf_usm_h%dz_wall
